/*
 * extension du dataArray
 *  pour les panier e-catalogue
 */

skDataArray.prototype.basket_headerName = new Array("", "Rfrence", "Dsignation", "Tarif unit. HT", "Quantit", "Total HT");
skDataArray.prototype.basket_headerWidth = new Array("8%", "15%", "35%", "18%", "10%", "14%");
skDataArray.prototype.basket_headerClass = new Array("th", "th th_ref", "th th_desi", "th th_pu", "th th_quant", "th th_pt");

skDataArray.prototype.basket_delta = function(delta) {
  this.total += Number(delta);

  // keep at most two digits after the dot
  this.total_label.setAttribute("value",
    Math.round(this.total * this.coef * 100) / 100);
}

skDataArray.prototype.basket_changeCoef = function(textbox) {
  var coef = textbox.value;
  if (coef[coef.length - 1] == '.')
    return;

  var coef = Number(coef);
  if (isNaN(coef) || coef < 0)
    coef = 0;
  textbox.value = coef;

  textbox.value = textbox.value.replace(/,/, ".");
  this.coef = Number(textbox.value);
  this.basket_delta(0);
  if(this.baskets){
    this.baskets.changeValue(this.basketName, 0, this.coef);
  }
}

skDataArray.prototype.basket_changeCount = function(textbox) {
  var count = textbox.value;
  if (count[count.length - 1] == '.')
    return;

  count = Number(count);
  if (isNaN(count) || count < 0)
    count = 0;
  textbox.value = count;

  var last_count = textbox.getAttribute("save");
  var siblings = textbox.parentNode.parentNode.childNodes;
  var checkbox = siblings[0].childNodes[0];
  var price = siblings[3].childNodes[0];
  var subprice = siblings[5].childNodes[0];

  if (checkbox.nodeName == 'checkbox' && !checkbox.checked) {
    checkbox.checked = true;
    last_count = 0;
  }else{
    this.basket_delta( - last_count * price.nodeValue);
  }

  subprice.nodeValue = Math.round(price.nodeValue * count * 100) / 100;
  this.basket_delta(price.nodeValue * count);
  textbox.setAttribute("save", count);

  if(this.baskets){
    var nbLine = textbox.getAttribute('id').replace(/.*?_/, '');
    var check = checkbox.checked;
    this.baskets.changeValue(this.basketName, nbLine, textbox.value+''+(check?'1':'0'));
  }
}

skDataArray.prototype.basket_checkbox = function(checkbox) {
  var b = checkbox.checked;
  var siblings = checkbox.parentNode.parentNode.childNodes;
  var price = siblings[3].childNodes[0];
  var count = siblings[4].childNodes[0];
  var subprice = siblings[5].childNodes[0];

  if (!b) {
    subprice.nodeValue = 0;
    this.basket_delta( - price.nodeValue * count.value);
  } else {
    subprice.nodeValue = price.nodeValue * count.value;
    this.basket_delta(price.nodeValue * count.value);
  }
  if(this.baskets){
    var nbLine = checkbox.getAttribute('id').replace(/.*?_/, '');
    this.baskets.changeValue(this.basketName, nbLine, count.value+''+(b?'1':'0'));
  }
};

skDataArray.prototype.basket_setHeader = function(da, td, w) {
   // `this' is not usable
  td.setAttribute("width", da.basket_headerWidth[w]);
  td.setAttribute("class", da.basket_headerClass[w]);
  td.appendChild(document.createTextNode(da.basket_headerName[w]));
}
