/* RE to select styles to be copied */
/* Should the RE be case-insensitive? */
/*
EXAMPLE

skCopy.add(oVList.getObjVList(index).selectedItem);
skCopy.setText(COPYRIGHT_GLOBAL, false);
skCopy.setHTML("<center><b>" + COPYRIGHT_GLOBAL + "</b></center>", false);
skCopy.putInClipoard("text/unicode");

*/


function copyFunction(){
    this._init();
}
copyFunction.prototype = {
    _init: function (){
        this._aStyleDiv = ["display", "background-color", "margin-left", "color","font-family", "font-size", "font-size-adjust", "font-style", "font-variant", "font-weight", "text-decoration"];
        this._aStyleSpan = ["margin-left", "font-family", "font-size", "font-size-adjust", "font-style", "font-variant", "font-weight", "color", "text-decoration"];
        this._nbaStyleDiv = this._aStyleDiv.length;
        this._nbaStyleSpan = this._aStyleSpan.length;
        this._reCleanSpace = new RegExp("  +", "g");
        this._reCleanOddChar = new RegExp("\u2007", "g");
        this._reCleanStressMarks = new RegExp("([\u02D0\u02C8\u02CC])","g");
        this.aRemoveNode = new Array();
        this.aRemoveStyle = new Array();
        this.copyrightTop = "";
        this.copyrightBottom = "";
    },
    add: function (objOrString){
        this.aTXT_HTML = new Array();
        this.aTXT_HTML["TXT"] = "";
        this.aTXT_HTML["HTML"] = "";
        if((objOrString.toString()).match(new RegExp("object"))=="object"){
            this._node = objOrString;
            this._view = objOrString.ownerDocument.defaultView;
            this.getCopyNode();
        }else{
            this.getCopyXMLString(objOrString);
        }
    },
    getArrayCopy: function (){
        return this.aTXT_HTML;
    },
    getText: function (){
        return this.aTXT_HTML["TXT"];
    },
    setText: function (sTxt, bTop){ // ajoute le texte au debut ou a la fin ....   si bTop = true   text au debut; si bTop = false   text a la fin 
        if(bTop){
            this.aTXT_HTML["TXT"]  = sTxt + this.aTXT_HTML["TXT"];
        }else{
            this.aTXT_HTML["TXT"] += sTxt;
        }
        this.aTXT_HTML["TXT"].replace(new RegExp("\r\n\r\n","g"),"\r\n");
    },
    getHTML: function (){
        return this.aTXT_HTML["HTML"];
    },
    setHTML: function (sHtml, bTop){ // ajoute le html au debut ou a la fin dans la balise body ....  si bTop = true   text au debut; si bTop = false   text a la fin 
        if(bTop){
            this.aTXT_HTML["HTML"]  = sHtml + this.aTXT_HTML["HTML"];
        }else{
            this.aTXT_HTML["HTML"] += sHtml;
        }
    },
    setRemoveStyle: function (sTxt){ // supprime les styles non voulu   ex: skCopy.setRemoveStyle("color,background-color");
        sTxt = sTxt.replace(new RegExp(", +"),",", "g");
        sTxt = sTxt.replace(new RegExp(" +,"),",", "g");
        var aString = sTxt.split(",")
        var nb = aString.length;
        for(var i=0; i<nb; i++){
            this.aRemoveStyle[aString[i]] = true;
        }
    },
    setStyleXMLString: function (customStyle){ // accepte toute les string de la balise style  ex: skCopy.setStyleXMLString("color:blue; background-color: transparent;");
        if(customStyle && customStyle!=""){
            this.StyleXMLString = customStyle;
        }
    },
    setArrayRemoveNode: function (aNodes){ // liste de nom de node sous forme de Array    ex : skCopy.setArrayRemoveNode(["div", "table", "font"]);
        if(aNodes && aNodes.length>0){
            var nb = aNodes.length;
            for(var i=0; i<nb; i++){
                this.aRemoveNode[aNodes[i]] = true;
            }
        }
    },
    getCopyXMLString: function (sCopy){
        sCopy = sCopy.replace(new RegExp("<(/?)div", "gi"),"$1div").replace(new RegExp("<[^>]+>", "gi"),"").replace(new RegExp("(/?)div", "gi"),"<$1div");
        if(this.StyleXMLString){
            this.aTXT_HTML["HTML"] = sCopy.replace(new RegExp("<div[^>]*>", "gi"),"<div style='"+this.StyleXMLString+"'>");
        }else{
            this.aTXT_HTML["HTML"] = sCopy.replace(new RegExp("<div[^>]*>", "gi"),"<div>");
        }
        this.aTXT_HTML["TXT"] = sCopy.replace(new RegExp("<div[^>]*>", "gi"),"").replace(new RegExp("</div>", "gi"),"\r\n");
    },
    getCopyNode: function (indent, parRemoveNodes){
        try {
            var oChildNodeList = this._node.childNodes;
            /* browse the tree */
            var nbNode = oChildNodeList.length;
            for (var i=0; i<nbNode; i++) {
                var child = oChildNodeList[i];
                if (child.nodeType == Node.ELEMENT_NODE){
                    if (this.aRemoveNode[child.nodeName]) continue;
                    /* extract style */

                    var oComputedStyle = this._view.getComputedStyle(child, null);
                    var display = oComputedStyle.getPropertyValue("display");
                    if(display == "none") continue;
                    var sStyle  = "";
                    var tag = "span";
                    var nb = this._nbaStyleSpan;
                    var _Array = this._aStyleSpan;
                    if(display == "block"){
                        tag = "div";
                        this.setText("\r\n", false);
                        nb = this._nbaStyleDiv;
                        _Array = this._aStyleDiv;
                    }
                    var nodeIndent = 0;
                    for (var j=0; j<nb; j++){
                        var sProp = _Array[j];
                        var value = oComputedStyle.getPropertyValue(sProp);
                        if (value == "transparent" || value == "inline" || this.aRemoveStyle[sProp]) continue;
                        if (sProp == "margin-left" || sProp == "padding-left"){
                            nodeIndent += parseFloat(value);
                            continue;
                        }
                        sStyle += sProp + ":" + value + "; ";
                    }

                    if (nodeIndent != 0){
                        indent = nodeIndent;
                    }else{
                        indent = 0;
                    }
                    sStyle += "text-indent:" + (nodeIndent + indent) + "px";
                    this._node = child;
                    this.setHTML("<" + tag + " style='" + sStyle + "'>", false);
                    this.getCopyNode(indent, parRemoveNodes);
                    this.setHTML("</" + tag + ">", false);
                }else if (child.nodeType == Node.TEXT_NODE) {
                    var text = child.data.replace(this._reCleanSpace, " ").replace(this._reCleanOddChar, "") + " ";
                    this.setText(text.replace(this._reCleanStressMarks, ""), false);
                    this.setHTML(text.replace(this._reCleanStressMarks, "<span style='font-family: Doulos SIL;'>$1</span>"), false);
                }
            }
        } catch (err) {
            jsLog("ERROR function getNodeText:\n" + err);
        }
    },
    putInClipoard : function (psFlavor) {
        try {
            if(!this.aTXT_HTML["TXT"] && !this.aTXT_HTML["HTML"]) return;
            var xiTrans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
            if (!xiTrans) return;
            if(this.aTXT_HTML["HTML"]){
                if(this.copyrightTop!=""){
                    this.aTXT_HTML["HTML"] = "<div>" + this.copyrightTop + "<div>" + this.aTXT_HTML["HTML"];
                }
                if(this.copyrightBottom!=""){
                    this.aTXT_HTML["HTML"] += "<div>" + this.copyrightBottom + "<div>";
                }
                var htmlstring      = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
                if (htmlstring) {
                    htmlstring.data = "<html><body>" + this.aTXT_HTML["HTML"] + "</body></html>";
                    xiTrans.addDataFlavor("text/html");
                    xiTrans.setTransferData("text/html", htmlstring, String(this.aTXT_HTML["HTML"]).length*2);
                }
            }
            if(this.aTXT_HTML["TXT"]){
                if(this.copyrightTop!=""){
                    this.aTXT_HTML["TXT"] =this.copyrightTop + "\n" + this.aTXT_HTML["TXT"];
                }
                if(this.copyrightBottom!=""){
                    this.aTXT_HTML["TXT"] += "\n" + this.copyrightBottom;
                }
                var xiUnicodeString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
                if (xiUnicodeString) {
                    xiUnicodeString.data = this.aTXT_HTML["TXT"];
                    xiTrans.addDataFlavor(psFlavor);
                    xiTrans.setTransferData(psFlavor, xiUnicodeString, String(this.aTXT_HTML["TXT"]).length * 2);
                }
            }
            var xiClipboard = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
            if (!xiClipboard) return;

            xiClipboard.emptyClipboard(xiClipboard.kGlobalClipboard);
            xiClipboard.setData(xiTrans, null, xiClipboard.kGlobalClipboard);

            /****EN ATTENTE****/
            /*var xiRtfConverter = Components.classes['@idm.fr/sk_rtf;1'].createInstance().QueryInterface( Components.interfaces.skIRtf );
            xiRtfConverter.ignoreTables = true;
            xiRtfConverter.ignoreImages = true;
            try {
                showObj(xiRtfConverter);
                //xiRtfConverter.writeRtfToFile( fp.file, oIframe.contentDocument );
            } catch( e) {
                // an error will occur if the file has been locked from outside.
                AlertWithTitle('Erreur', 'Le fichier n\'a pu tre crit sur le disque.', poWindow);
            }
*/
        } catch (err) {
            jsLog("ERROR function putInClipoard:\n" + err);
        }
    }
}

var skCopy = new copyFunction();



/********************************************************************
 ** Unused functions (may be we keep them for old projects only ?) **
 *******************************************************************/

const _aStyleDiv = ["display", "background-color", "margin-left", "color","font-family", "font-size", "font-size-adjust", "font-style", "font-variant", "font-weight", "text-decoration"];
const _aStyleSpan = ["margin-left", "font-family", "font-size", "font-size-adjust", "font-style", "font-variant", "font-weight", "color", "text-decoration"];
const _nbaStyleDiv = _aStyleDiv.length;
const _nbaStyleSpan = _aStyleSpan.length;
const _reCleanSpace = new RegExp("  +", "g");
const _reCleanOddChar = new RegExp("\u2007", "g");
const _reCleanStressMarks = new RegExp("([\u02D0\u02C8\u02CC])","g");

//Format a node into styled HTML and TXT. 
//Warning: this function can be slow enough to popup the mozilla warning
//about the application being unresponsive.
function getCopyNode(poNode, indent, parRemoveNodes) {
    try {
        var aTXT_HTML = new Array();
        var oChildNodeList = poNode.childNodes;
        var view = poNode.ownerDocument.defaultView;
        aTXT_HTML["HTML"] = "";
        aTXT_HTML["TXT"]  = "";
        
        //browse the tree
        var nbNode = oChildNodeList.length;
        for (var i=0; i<nbNode; i++) {
            var child = oChildNodeList[i];
            if (child.nodeType == Node.ELEMENT_NODE) 
            {
                var bSkipNode = false;
                if (parRemoveNodes) {
                    for (var j = 0; j < parRemoveNodes.length && !bSkipNode ; j++) {
                        bSkipNode = (child.nodeName == parRemoveNodes[j]);
                    }
                    if (bSkipNode) continue;
                }
                //extract style
                var sStyle  = "";

                var oComputedStyle = view.getComputedStyle(child, null);
                var display = oComputedStyle.getPropertyValue("display");
                if(display != "none")
                {
                    var tag = "span";
                    var nb = _nbaStyleSpan;
                    var _Array = _aStyleSpan;
                    if(display == "block")
                    {
                        tag = "div";
                        aTXT_HTML["TXT"] += "\r\n";
                        nb = _nbaStyleDiv;
                        _Array = _aStyleDiv;
                    }
                    var nodeIndent = 0;
                    for (var j=0; j<nb; j++){
                        var sProp = _Array[j];
                        var value = oComputedStyle.getPropertyValue(sProp);
                        if (value == "transparent" || value == "inline")
                            continue;
                        if (sProp == "margin-left" || sProp == "padding-left") {
                            nodeIndent += parseFloat(value);
                            continue;
                        }
                        sStyle += sProp + ":" + value + "; ";
                    }

                    if (nodeIndent != 0){
                        indent = nodeIndent;
                    }
                    sStyle += "text-indent:" + (nodeIndent + indent) + "px";
                    var aTXT_HTML_TMP = getCopyNode(child, indent, parRemoveNodes);
                    aTXT_HTML["HTML"] += "<" + tag + " style='" + sStyle + "'>"+
                        aTXT_HTML_TMP["HTML"] + "</" + tag + ">";
                    aTXT_HTML["TXT"] += aTXT_HTML_TMP["TXT"];
                }
  

            }else if (child.nodeType == Node.TEXT_NODE) {
                var text = child.data.replace(_reCleanSpace, " ").replace(_reCleanOddChar, "") + " ";
                aTXT_HTML["TXT"] += text.replace(_reCleanStressMarks, "");
                aTXT_HTML["HTML"] += text.replace(_reCleanStressMarks, "<span style='font-family: Doulos SIL;'>$1</span>");
            }
        }
        aTXT_HTML["TXT"] = aTXT_HTML["TXT"].
            replace(new RegExp("\r\n\r\n","g"),"\r\n");

        return aTXT_HTML;
    } catch (err) {
        jsLog("ERROR function getNodeText:\n" + err);
    }
}

function copyList(str,customStyle){
    var aTXT_HTML = new Array();
    str = str.replace(new RegExp("<(/?)div", "gi"),"$1div").replace(new RegExp("<[^>]+>", "gi"),"").replace(new RegExp("(/?)div", "gi"),"<$1div");
    aTXT_HTML["HTML"] = str.replace(new RegExp("<div[^>]*>", "gi"),"<div style='"+customStyle+"'>");
    aTXT_HTML["TXT"] = str.replace(new RegExp("<div[^>]*>", "gi"),"")
        .replace(new RegExp("</div>", "gi"),"\r\n");
    return aTXT_HTML;
}

function putInClipoard(psSelectionTXT, psSelectionHTML, psFlavor) {
    try {
        if(!psSelectionHTML && !psSelectionTXT) return;
        var xiTrans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        if (!xiTrans) return;

        if(psSelectionHTML){
            var htmlstring      = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
            if (htmlstring) {
                htmlstring.data = "<html><body>" + psSelectionHTML + "</body></html>";
                xiTrans.addDataFlavor("text/html");
                xiTrans.setTransferData("text/html", htmlstring, String(psSelectionHTML).length*2);
            }
        }
        if(psSelectionTXT){
            var xiUnicodeString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
            if (xiUnicodeString) {
                xiUnicodeString.data = psSelectionTXT;
                xiTrans.addDataFlavor(psFlavor);
                xiTrans.setTransferData(psFlavor, xiUnicodeString, String(psSelectionTXT).length * 2);
            }
        }
        var xiClipboard = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
        if (!xiClipboard) return;

        xiClipboard.emptyClipboard(xiClipboard.kGlobalClipboard);
        xiClipboard.setData(xiTrans, null, xiClipboard.kGlobalClipboard);
    } catch (err) {
        jsLog("ERROR function putInClipoard:\n" + err);
    }
}
