/*
 * Panier arborescent
 *  pour l'instant il ne gere qu'un niveaux
 *  a faire :
 *    - gestion multi-niveaux
 */

function skBasketArbo(poWin, psMasterName) {
  this.win = poWin;
  this.master = psMasterName;
  this.initBasketMaster();
}
skBasketArbo.prototype = {
  xoBasket: null,
  win: null,
  master: null,

  initBasketMaster: function(){
    this.loadBasket(this.master);
  },

  getBasketObject: function (){
    return this.xoBasket;
  },

  /*cette fonction initialise les fichier d'historic*/
  loadBasket: function(psNomPanier){
    try {
      if(this.xoBasket == null){
        this.xoBasket = Components.classes["@idm.fr/sk_basket;1"].createInstance().QueryInterface(Components.interfaces.skIBasket);
        this.xoBasket.SetWindow(this.win);
      }
      if (this.xoBasket) {
        if(this.getIdBasket(psNomPanier) == -1){
          this.xoBasket.AddBasket(psNomPanier);
          if(psNomPanier != this.master){
            this.addToBasket(this.master, this.getIdBasket(psNomPanier), psNomPanier);
          }
        }
      }
    }catch (e){
      throw ("ERROR function skBasketArbo:loadBasket("+psNomPanier+") :\n" + e);
    }
  },

  getIdBasket: function(psNomPanier){
    try{
      return this.xoBasket.GetBasketIndexByName(psNomPanier);
    }catch(e){
      throw ("ERROR function skBasketArbo:getIdBasket("+psNomPanier+") :\n"+e);
    }
  },

  getIdMasterBasket: function(){
    return this.getIdBasket(this.master);
  },

  addToBasket: function(psNomPanier, psKey, psContent){
    try{
      this.xoBasket.AddContentInBasket(psKey, psContent, this.getIdBasket(psNomPanier));
    }catch(e){
      throw ("ERROR function skBasketArbo:addToBasket("+psNomPanier+", "+psKey+", "+psContent+") :\n"+e);
    }
  },

  removeBasket: function(psNameBasket){
    try{
      if(this.getIdBasket(psNameBasket) > -1 && this.getIdOfBasketInMaster(psNameBasket) > -1){
        this.xoBasket.RemoveBasket(this.getIdBasket(psNameBasket));
        this.xoBasket.RemoveElement(this.getIdMasterBasket(), this.getIdOfBasketInMaster(psNameBasket));
      }
    }catch(e){
      throw ("ERROR function skBasketArbo:removeBasket("+psNameBasket+") :\n"+e);
    }
  },

  getIdOfBasketInMaster: function(psNameBasket){
    try{
      var iIdMaster = this.getIdMasterBasket()
      for(var i=0;i<this.xoBasket.BasketContentCount(iIdMaster);i++){
        if(this.xoBasket.ReadNameAt(iIdMaster, i) == psNameBasket){
          return i;
        }
      }
      return -1;
    }catch(e){
      throw ("ERROR function skBasketArbo:getIdOfBasketInMaster("+psNameBasket+") :\n"+e);
    }
  },

  isEmptyBasket: function(psNomPanier){
    try{
      if( this.xoBasket.BasketContentCount(this.getIdBasket(psNomPanier)) == 0 )
        return true;
      return false;
    }catch(e){
      throw ("ERROR function skBasketArbo:isEmptyBasket("+psNomPanier+") :\n"+e);
    }
  },

  emptyBasket: function(psNomPanier){
    try{
      this.xoBasket.EmptyBasket(this.getIdBasket(psNomPanier));
    }catch(e){
      throw ("ERROR function skBasketArbo:emptyBasket("+psNomPanier+") :\n"+e);
    }
  },

  renameBasket: function(psOld, psName){
    try{
      if(psOld != this.master){
        var old = this.getIdBasket(psOld)
        this.xoBasket.RenameElement(psName, this.getIdMasterBasket(), this.getIdOfBasketInMaster(psOld));
        this.xoBasket.RenameBasket(psName, old);
      }else{
        this.xoBasket.RenameBasket(psName, old);
        this.master = psName;
      }
      return psName;
    }catch(e){
      throw ("ERROR function skBasketArbo:renameBasket("+psOld+", "+psName+") :\n"+e);
    }
  },

  createBasket: function(psName){
    try{
      this.loadBasket(psName);
      return psName;
    }catch(e){
      throw ("ERROR function skBasketArbo:createBasket("+psName+") :\n"+e);
    }
  },

  getKey: function(psName, piLine){
    try{
      var idBasket = this.getIdBasket(psName);
      return this.xoBasket.ReadKeyAt(idBasket, piLine);
    }catch(e){
      throw ("ERROR function skBasketArbo:getKey("+psName+", "+piLine+") :\n"+e);
    }
  },

  changeValue: function(psBasketName, piLine, psValue){
    try{
      var idBasket = this.getIdBasket(psBasketName);
      this.xoBasket.RenameElement(psValue, idBasket, piLine);
    }catch(e){
      throw ("ERROR function skBasketArbo:getValue("+psName+", "+piLine+") :\n"+e);
    }
  },

  getValue: function(psName, piLine){
    try{
      var idBasket = this.getIdBasket(psName);
      return this.xoBasket.ReadNameAt(idBasket, piLine);
    }catch(e){
      throw ("ERROR function skBasketArbo:getValue("+psName+", "+piLine+") :\n"+e);
    }
  },

  getCount: function(psName){
    try{
      var idBasket = this.getIdBasket(psName);
      return this.xoBasket.BasketContentCount(idBasket);
    }catch(e){
      throw ("ERROR function skBasketArbo:getCount("+psName+") :\n"+e);
    }
  },

  getMasterContent: function(pbSimpleList){
    try{
      var tab = new Array();
      if(pbSimpleList) tab[tab.length] = '';
      for(var i=0;i<this.getCount(this.master);i++){
        var ref = this.getKey(this.master, i);
        var name = this.getValue(this.master, i);
        tab[tab.length] = (pbSimpleList?name:[name, [ref, name]]);
      }
      tab = tab.sort();
      return tab;
    }catch(e){
      throw ("ERROR function skBasketArbo:getMasterContent() :\n"+e);
    }
  },

  removeFromBasket: function(psNameBasket, piLine){
    try{
      if(this.getIdBasket(psNameBasket) > -1 && piLine < this.getCount(psNameBasket)){
        this.xoBasket.RemoveElement(this.getIdBasket(psNameBasket), piLine);
      }
    }catch(e){
      throw ("ERROR function skBasketArbo:removeFromBasket("+psNameBasket+") :\n"+e);
    }
  },

  getContent: function(psNameBasket, pbSimpleList){
    try{
      var tab = new Array();
      if(pbSimpleList) tab[tab.length] = '';
      for(var i=0;i<this.getCount(psNameBasket);i++){
        var ref = this.getKey(psNameBasket, i);
        var name = this.getValue(psNameBasket, i);
        tab[tab.length] = (pbSimpleList?name:[ref, name]);
      }
      return tab;
    }catch(e){
      throw ("ERROR function skBasketArbo:getContent() :\n"+e);
    }
  },

  keyIsInBasket: function(psNameBasket, psKey){
    try{
      var tab = this.getContent(psNameBasket);
      for(var i=0;i<tab.length;i++){
        if(tab[i][0] == psKey){
          return true;
        }
      }
      return false;
    }catch(e){
      throw ("ERROR function skBasketArbo:keyIsInBasket() :\n"+e);
    }
  },
}
