function Resizer() { this.init(); }

Resizer.prototype.init = function (id){
    this.defaultSizeArray=[];
    this.WIDTH = 0;
    this.HEIGHT = 1;
    this.currentObjectSize = null;;
    var me =this;
    // Functions for event listener - store them in the object so we can remove them later
    // Use closures so we don't lose the Resizer object
    this.winResizeMaxWidth = function() { me.resizeMaxWidth() };
    this.winResizeMaxHeight = function() { me.resizeMaxHeight() };
    this.winResizeMinWidth = function() { me.resizeMinWidth() };
    this.winResizeMinHeight = function() { me.resizeMinHeight() };

}

Resizer.prototype.addDefaultSizeArray = function (id, objSize){
    this.defaultSizeArray[id] = objSize;
}
Resizer.prototype.getDefaultSizeArray = function (id){
    return this.defaultSizeArray[id];
}
Resizer.prototype.changeSize = function (id){
    var objSize = this.getDefaultSizeArray(id);
    if(!objSize) return;
    if(this.currentObjectSize){
        this.currentObjectSize.currentWidth  = this.currentObjectSize.win.outerWidth;
        this.currentObjectSize.currentHeight = this.currentObjectSize.win.outerHeight;
        this.removeEvent(this.currentObjectSize);
    }

    this.currentObjectSize = objSize;
    this.currentObjectSize.win.outerWidth  = (this.currentObjectSize.currentWidth !=null)?this.currentObjectSize.currentWidth:this.currentObjectSize.defaultWidth;
    this.currentObjectSize.win.outerHeight = (this.currentObjectSize.currentHeight !=null)?this.currentObjectSize.currentHeight:this.currentObjectSize.defaultHeight;

    this.addEvent();

    this.currentObjectSize.currentWidth  = this.currentObjectSize.win.outerWidth;
    this.currentObjectSize.currentHeight = this.currentObjectSize.win.outerHeight;
}

Resizer.prototype.addEvent = function (){
    var win = this.currentObjectSize.win;
    if( this.currentObjectSize.maxWidth != null )
        win.addEventListener("resize", this.winResizeMaxWidth, true);
    if( this.currentObjectSize.maxHeight != null )
        win.addEventListener("resize", this.winResizeMaxHeight, true);
    if( this.currentObjectSize.minWidth != null )
        win.addEventListener("resize", this.winResizeMinWidth, true);
    if( this.currentObjectSize.minHeight != null )
        win.addEventListener("resize", this.winResizeMinHeight, true);
}

Resizer.prototype.resizeMaxWidth =  function (){
                                        var win = this.currentObjectSize.win;
                                        if(this.currentObjectSize.maxWidth !=null && win.outerWidth > this.currentObjectSize.maxWidth)
                                            this.resize(this.WIDTH, this.currentObjectSize.maxWidth)
                                    }
Resizer.prototype.resizeMaxHeight = function (){
                                        var win = this.currentObjectSize.win;
                                        if(this.currentObjectSize.maxHeight !=null && win.outerHeight > this.currentObjectSize.maxHeight)
                                            this.resize(this.HEIGHT, this.currentObjectSize.maxHeight)
                                    }
Resizer.prototype.resizeMinWidth =  function (){
                                        var win = this.currentObjectSize.win;
                                        if(this.currentObjectSize.minWidth !=null && win.outerWidth < this.currentObjectSize.minWidth)
                                            this.resize(this.WIDTH, this.currentObjectSize.minWidth)
                                    }
Resizer.prototype.resizeMinHeight = function(){
                                        var win = this.currentObjectSize.win;
                                        if(this.currentObjectSize.minHeight !=null && win.outerHeight < this.currentObjectSize.minHeight)
                                            this.resize(this.HEIGHT, this.currentObjectSize.minHeight)
                                    }

Resizer.prototype.removeEvent = function (){
    var win = this.currentObjectSize.win;
    win.removeEventListener("resize", this.winResizeMaxWidth, true);
    win.removeEventListener("resize", this.winResizeMaxHeight, true);
    win.removeEventListener("resize", this.winResizeMinWidth, true);
    win.removeEventListener("resize", this.winResizeMinHeight, true);
}

Resizer.prototype.resize = function (orient, size){
    var win = this.currentObjectSize.win;
    if(orient==this.WIDTH ){
        win.outerWidth  = size;
        this.currentObjectSize.currentWidth  = win.outerWidth;
    }
    if(orient==this.HEIGHT){
        win.outerHeight = size;
        this.currentObjectSize.currentHeight = win.outerHeight;
    }
}

var resizerWin = new Resizer();



function ObjectSize(){this.init();}

ObjectSize.prototype.init = function (){
    this.win           = window;
    this.defaultWidth  = null;
    this.defaultHeight = null;
    this.maxWidth      = null;
    this.maxHeight     = null;
    this.minWidth      = null;
    this.minHeight     = null;
    this.currentWidth  = null;
    this.currentHeight = null;
}


