function skMp3ManagerObj(){
    this.init();
}
skMp3ManagerObj.prototype = {
    init: function (){
        this.sk_Mp3 = Components.classes["@idm.fr/sk_mp3;1"].createInstance();
        this.sk_Factory = Components.classes["@idm.fr/sk_factory;3"].getService();
        this.sk_Factory.Init();
        this.fsName = null;
        this.lastFsName;
        this.cdName = null;
        this.titleBox = "Disk requested";
        this.messageBox = "Insert disk";
        this.messageOkBox = "Ok";
        this.messageConcelBox = "Cancel";
        this.bInitApp = true;
        this.oSkFs = Components.classes["@idm.fr/sk_file_system;3"].createInstance();
        this.alertMode = false;
    },
    setPathPrev: function(pathPrev){
        if(pathPrev.split("/")[0] == "..") pathPrev = this.sk_Factory.GetEnv("PATH") + "/" + pathPrev;
        this.sk_Factory.SetEnv("PATH", pathPrev + ";" + this.sk_Factory.GetEnv("PATH"));
    },
    play: function (psUrl, failSilently, bUrlId){
        try{
            if (this.bInitApp) return;
            if (this.isPlaying()) return;
            if (!psUrl) return;
            window.setCursor("wait");
            var oSkFs = this.oSkFs;
            if (this.fsName != this.lastFsName) {
                try {
                    this.oSkFs.SetFileName(this.fsName);
                    this.lastFsName = this.fsName;
                }catch (e) {
                    if (!failSilently) {
                        var bFailed = true;
                        while(bFailed) {
                            try {
                                this.sk_Factory.AddDisk(this.cdName, false);
                                this.oSkFs.SetFileName(this.fsName);
                                bFailed = false;
                            } catch(e) {
                                if (this.alertMode) {
                                    AlertWithTitle(this.titleBox, this.messageBox);
                                    bFailed = false;
                                    bAbort = true;
                                } else if (!ConfirmWithTitle(this.titleBox, this.messageBox, this.messageOkBox, this.messageConcelBox)) {
                                    bFailed = false;
                                    bAbort = true;
                                }
                            }
                        }
                    }
                }
            }
            var bAbort = false;
            window.setCursor("auto");
            if (bAbort || !oSkFs)
                return;
            var oSoundFile;
            if(bUrlId){
				oSoundFile = oSkFs.GetFile( psUrl);
			}else{
				oSoundFile = oSkFs.GetFileByPath( psUrl);
			}
            if (!oSoundFile)
                return;

            this.stop();
            this.sk_Mp3.setsound(oSoundFile.GetData());
            this.sk_Mp3.play(true);
            this.playLoop();
        } catch (err) {
            window.setCursor("auto");
            jsLog("ERROR function skMp3Manager.play :\n" + err + "\nURL : "+psUrl);
        }
    },
    playLoop: function (callback){
        if (callback)
            eval(callback);
        else {
            window.setCursor("wait");
            if(!this.sk_Mp3.isPlaying()){
                window.setCursor("auto");
                return;
            }
        }
        var objThis = this;
        setTimeout(function(){objThis.playLoop()}, 10);
    },
    isPlaying: function() {
        try{
            return this.sk_Mp3.isPlaying();
        } catch (err) {
        }
    },
    stop: function() {
        try{
            this.sk_Mp3.stop();
        } catch (err) {
        }
    }
}

var skMp3Manager = new skMp3ManagerObj()
