function skPopupObj(){
    this.init();
}
skPopupObj.prototype = {
    init: function (){
        this.xiSkPopupManager = Components.classes["@idm.fr/sk_popup_manager;1"].createInstance().QueryInterface(Components.interfaces.skIPopupManager);
        this.pref             = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
        if(!this.xiSkPopupManager) return false;
        this.xiSkPopupManager.Init(window);
    },
    isAlreadyOpened: function (psIdWindow, bFocus){
        if(!this.xiSkPopupManager) return this.init();
        var xChromeWindow = this.xiSkPopupManager.ReturnPopupById(psIdWindow);

        if (xChromeWindow) {
            if(bFocus) xChromeWindow.focus();
            return xChromeWindow;
        }
        return false;
    },
    getWindowPopupById: function (psIdWindow){
        return this.xiSkPopupManager.ReturnPopupById(psIdWindow);
    },
    getWindowsPopupByType: function (psTypeWindow){
        var winArray = new Array();
        var nsiArray = this.xiSkPopupManager.ReturnPopupByType(psTypeWindow);
        for(var i=0; i<nsiArray.Count(); i++){ 
            winArray[winArray.length] = nsiArray.GetElementAt(i);
        }
        return winArray;
    },
    getAllWindowPopupArray: function (){
        var winArray = new Array();
        var nsiArray = this.xiSkPopupManager.ReturnAllPopups();
        for(var i=0; i<nsiArray.Count(); i++){ 
            winArray[winArray.length] = nsiArray.GetElementAt(i);
        }
        return winArray;
    },
    closePopupById: function (psIdWindow){
        if(!this.xiSkPopupManager) return this.init();
        if (!this.isAlreadyOpened(psIdWindow)) return;
        this.xiSkPopupManager.ClosePopupById(psIdWindow);
    },
    closePopupByType: function (psType){
        if(!this.xiSkPopupManager) return this.init();
        var aPopup = this.getWindowsPopupByType(psType);
        for (var i=0; i<aPopup.length; i++) {
            aPopup[i].close();
        }
    },
    closePopupsOfType: function (paWindowType){
        if(!this.xiSkPopupManager) return this.init();
        var nbType = paWindowType.length;
        for (var i=0; i<nbType; i++) {
            this.closePopupByType(paWindowType[i]);
        }
    },
    closeAllPopups: function (){
        if(!this.xiSkPopupManager) return this.init();
        var aPopup = this.getAllWindowPopupArray();
        for (var i=0; i<aPopup.length; i++) {
            aPopup[i].close();
        }
    },
    closeAllPopupsExcept: function (aSaveMeId){
        if(!this.xiSkPopupManager) return this.init();
        var aPopup = this.getAllWindowPopupArray();
        // aSaveMeId is an array of window ids we don't want closed
        // we put it into a hash for convenience
        var aHashSaveMeId = new Array();
        var id;
        for (var i=0; i<aSaveMeId.length; i++) {
          aHashSaveMeId[ aSaveMeId[i] ] = true;
        }

        for (var i=0; i<aPopup.length; i++) {
            id = aPopup[i].id;
            if (!aHashSaveMeId[id])
              aPopup[i].close();
        }
    },
    closePopupChildren: function (win) {
        if(!this.xiSkPopupManager) return this.init();
        var aPopup = this.getAllWindowPopupArray();
        for (var i=0; i<aPopup.length; i++) {
            if (aPopup[i].winOpener == win)
              aPopup[i].close();
        }
    },
    initNewPopup: function (sWindowId, sMode, pbSaveProperties){
        this.windowId = sWindowId;
        if (this.isAlreadyOpened(sWindowId)) return this.isAlreadyOpened(sWindowId);
        this.initWindowPopup = new createPopup(this, sWindowId, sMode, pbSaveProperties);
        return this.initWindowPopup;
    },
    openPopup: function (){
        if (this.isAlreadyOpened(this.windowId)) return this.isAlreadyOpened(this.windowId);
        var winPop = this.initWindowPopup.open();
        this.initWindowPopup = null;
        return winPop;
    },
    savePopupProperties: function(psWindowId) {
        var oPopup = this.getWindowPopupById(psWindowId);
        if (!oPopup.saveProperties)
            return;

        this.pref.SetIntPref("plugs.skPopup." + psWindowId + ".screenX", oPopup.screenX);
        this.pref.SetIntPref("plugs.skPopup." + psWindowId + ".screenY", oPopup.screenY);
        this.pref.savePrefFile(null);
    }
}

var skPopup = new skPopupObj()

function createPopup(skPopupObj, sWindowId, sMode, pbSaveProperties){
    this.init(skPopupObj, sWindowId, sMode, pbSaveProperties);
}
createPopup.prototype = {
    init: function (skPopupObj, sWindowId, sMode, pbSaveProperties){
        this.width = null;
        this.height = null;
        this.posX = null;
        this.posY = null;
        this.minWidth = null;
        this.minHeight = null;
        this.maxWidth = null;
        this.maxHeight = null;
        this.resize = null;
        this.titleBar = null;
        this.title = null;
        this.depend = null;
        this.alwaysRaised = null;
        this.chrome = null;
        this.modal = null;
        this.url = null;
        this.winOpener = window;
        this.center = null;
        this.extraArgs = new Array();
        this.saveProperties = pbSaveProperties;
        this._skPopupObj = skPopupObj;
        this._xiSkPopupManager = skPopupObj.xiSkPopupManager;
        this._sWindowId = sWindowId;
        this._sMode = sMode != null ? sMode : this._sWindowId;
    },
    open: function (){
        if (!this._skPopupObj.isAlreadyOpened(this._sWindowId)){
            this.defaultInit();
            this.height       = this.height - (window.outerHeight - window.innerHeight);
            this.width        = this.width - (window.outerWidth - window.innerWidth);
            var oPref         = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
            var bPropertyPref = (oPref.GetPrefType("plugs.skPopup." + this._sWindowId + ".screenX") != 0);

            if (this.saveProperties && bPropertyPref) {
                this.posX = oPref.GetIntPref("plugs.skPopup." + this._sWindowId + ".screenX");
                this.posY = oPref.GetIntPref("plugs.skPopup." + this._sWindowId + ".screenY");
            }

            var strArgs = "chrome="+this.chrome+",dependent="+this.depend+",modal="+this.modal+",alwaysRaised="+this.alwaysRaised+",resizable="+this.resize
            +',titlebar='+this.titleBar+',width='+this.width+',height='+this.height+',left='+this.posX+',top='+this.posY+',centerscreen='+this.center;
            var oPopup = this._xiSkPopupManager.OpenPopup( this.url, strArgs, this._sMode, this._sWindowId, this.winOpener);
            var bSaveProperties = this.saveProperties;
            var skPopupObj = this._skPopupObj;
            var sWindowId = this._sWindowId;
            var win = this.winOpener;
            var extraArgs = this.extraArgs;
            var minW = this.minWidth - (window.outerWidth - window.innerWidth);
            var minH = this.minHeight - (window.outerHeight - window.innerHeight);
            var title = this.title;
            var winGM = window;
            oPopup.addEventListener("load", function()
                {
                    oPopup.winOpener = win;
                    oPopup.winGM = winGM;
                    oPopup.extraArgs = extraArgs;
                    oPopup.minW = minW;
                    oPopup.minH = minH;
                    oPopup.saveProperties = bSaveProperties;
                    if (title)
                        oPopup.document.title = title;
                    oPopup.addEventListener("unload",
                        function closeThisPopup()
                        {
                            skPopupObj.savePopupProperties(sWindowId);
                            skPopupObj.closePopupById(sWindowId);
                            /* The following code causes problems in CSD. If
                               this is required in other projects, then it
                               should be configurable.
                               --
                               krys
                            */
                            /*
                            var aWin = skPopupObj.getAllWindowPopupArray();
                            if(aWin.length!=0) window.setTimeout(function(){aWin[aWin.length-1].focus()}, 0);
                            */
                        }, false);
                    oPopup.addEventListener("resize", function()
                        {
                            // Before Vista, inner{Width,Height} were
                            // outer{Width,Height}.
                            if(oPopup.innerWidth  < oPopup.minW)
                                oPopup.innerWidth = oPopup.minW;
                            if(oPopup.innerHeight < oPopup.minH)
                                oPopup.innerHeight = oPopup.minH;
                        }, false);
                    oPopup.id = sWindowId;
                }, false);
            return oPopup;
        }
    },
    defaultInit: function (){
        if(this.width == null) this.width = 50;
        if(this.height == null) this.height = 50;
        if(this.posX == null) this.posX = window.screenX + (window.outerWidth/2) - (this.width/2);
        if(this.posY == null) this.posY = window.screenY + (window.outerHeight/2) - (this.height/2);
        if(this.minWidth == null) this.minWidth = this.width;
        if(this.minHeight == null) this.minHeight = this.height;
        if(this.maxWidth == null) this.maxWidth = -1;
        if(this.maxHeight == null) this.maxHeight = -1;
        if(this.resize == null || this.resize == "" ) this.resize = "no";
        if(this.titleBar == null || this.titleBar == "" ) this.titleBar = "yes";
        if(this.depend == null || this.depend == "" ) this.depend = "yes";
        if(this.alwaysRaised == null || this.alwaysRaised == "" ) this.alwaysRaised = "yes";
        if(this.chrome == null || this.chrome == "" ) this.chrome = "yes";
        if(this.modal == null || this.modal == "" ) this.modal = "no";
        if(this.url == null || this.url == "" ) this.url = "about:blank";
        if(this.winOpener == null || this.winOpener == "") this.winOpener = window;
        if(this.center == null || this.center == "" ) this.center = "no";
    }
}

