function skPrintManagerObj(){
    this.init();
}
skPrintManagerObj.prototype = {
    init: function (){
        this.printManager = Components.classes["@idm.fr/sk_print_manager;1"].createInstance().QueryInterface(Components.interfaces.skIPrintManager);
        this.paperSizeType = null;
        this.headerStrLeft = null;
        this.headerStrCenter = null;
        this.headerStrRight = null;
        this.footerStrRight = null;
        this.footerStrLeft = null;
        this.footerStrCenter = null;
        this.showPrintProgress = null;
        this.printBGColors = null;
        this.printBGImages = null;
        this.printRange = null;
    },
    print: function (pWindow){
        this.defaultValue(pWindow);
        try {
            this.printManager.AddPrintSettingsToPrefs('paperSizeType', this.paperSizeType);
            this.printManager.AddPrintSettingsToPrefs('headerStrLeft', this.headerStrLeft);
            this.printManager.AddPrintSettingsToPrefs('headerStrCenter', this.headerStrCenter);
            this.printManager.AddPrintSettingsToPrefs('headerStrRight', this.headerStrRight);
            this.printManager.AddPrintSettingsToPrefs('footerStrRight', this.footerStrRight);
            this.printManager.AddPrintSettingsToPrefs('footerStrLeft', this.footerStrLeft);
            this.printManager.AddPrintSettingsToPrefs('footerStrCenter', this.footerStrCenter);
            this.printManager.AddPrintSettingsToPrefs('showPrintProgress', this.showPrintProgress);
            this.printManager.AddPrintSettingsToPrefs("printBGColors", this.printBGColors);
            this.printManager.AddPrintSettingsToPrefs("printBGImages", this.printBGImages);
            this.printManager.AddPrintSettingsToPrefs("printRange", this.printRange);
            this.printManager.Print(pWindow, this.printManager.kPrefsSettings);
        } catch (err) {
            jsLog("ERROR function skPrintManager.print :\n" + err)
        }
    },
    defaultValue: function (pWindow){
        try {
            if(!this.paperSizeType) this.paperSizeType = '0';
            if(!this.headerStrLeft) this.headerStrLeft = '';
            if(!this.headerStrCenter) this.headerStrCenter = 'IDM CD-ROM';
            if(!this.headerStrRight) this.headerStrRight = '';
            if(!this.footerStrRight) this.footerStrRight = '';
            if(!this.footerStrLeft) this.footerStrLeft = '';
            if(!this.footerStrCenter) this.footerStrCenter = ' IDM, ' + ((new Date).getFullYear() + 1);
            if(!this.showPrintProgress) this.showPrintProgress = false;
            if(!this.printBGColors) this.printBGColors = true;
            if(!this.printBGImages) this.printBGImages = true;
            //Use to check selection button in the print interface--> don't work
            if(!this.printRange){
                var oSelection = pWindow.getSelection();
                if(oSelection.rangeCount > 0){
                    this.printRange = '2';
                }else{
                    this.printRange = '0';
                }
            }
        } catch (err) {
            jsLog("ERROR function skPrintManager.default :\n" + err)
        }
    }


}

var skPrintManager = new skPrintManagerObj()
