/* ***************************************************************************
   *
   * File : utils.js                               $Revision: 1.20 $
   *                                               $Date: 2006/10/10 13:57:25 $
   *                                               $Author: maxime $
   *                                               $Name:  $
   * Purpose :
   *
   * Regrouping all utils functions
   *
   ***************************************************************************
*/

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
/******
Cree une boite d'alert avec un titre
title           ---> titre du futur alert
message         ---> message du futur alert
parentWindow    ---> option de passage d'une window
******/
function AlertWithTitle(title, message, parentWindow){
    if (!parentWindow)
        parentWindow = window;

        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
        promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

    if (promptService){
        if (!title)
              title = GetString("Alert");

        // "window" is the calling dialog window
        promptService.alert(parentWindow, title, message);
    }
}

/******
Cree un prompt avec un titre
title           ---> titre du futur alert
message         ---> message du futur alert
value           ---> message par defaut
parentWindow    ---> option de passage d'une window
******/
function PromptWithTitle(title, message, value, parentWindow, checkLabel, checkValue) {
    if (!parentWindow)
        parentWindow = window;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

    if (promptService) {
        if (!title)
            title = "Prompt";

        if(!checkValue)
          checkValue = {value:0};

        // "window" is the calling dialog window
        return promptService.prompt(parentWindow, title, message, value, checkLabel, checkValue);
    }
}

/******
Cree une boite de confirmation avec un titre
title           ---> titre du futur alert
message         ---> message du futur alert
okButtonText    ---> text ok
cancelButtonText---> text cancel
******/
function ConfirmWithTitle(title, message, okButtonText, cancelButtonText, parentWindow) {
    if (!parentWindow)
        parentWindow = window;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

    if (promptService) {
        var okFlag = okButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_OK;
        var cancelFlag = cancelButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_CANCEL;

        return promptService.confirmEx(parentWindow, title, message,
                                      (okFlag * promptService.BUTTON_POS_0) +
                                      (cancelFlag * promptService.BUTTON_POS_1),
                                      okButtonText, cancelButtonText, null, null, {value:0}) == 0;
    }
    return false;
}

/******
Cree une boite de selection avec un titre
title           ---> titre du futur alert
message         ---> message du futur alert
values          ---> liste des valeurs selectiionnable
parentWindow    ---> option de passage d'une window
******/
function SelectWithTitle(title, message, values, parentWindow){
    if (!parentWindow)
        parentWindow = window;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

    if (promptService){
        if (!title)
              title = GetString("Select");
        var out = {value: 0};
        var confirmed = promptService.select (parentWindow, title, message, values.length, values, out);
        if(confirmed){
          return out.value
        }
    }
    return null;
}

/******
Ouvre une url dans le browser par defaut
psUrl             ---> url a ouvrir
******/
function openDefBrowser(psUrl, psParams, psExecutableName) {
    /* Open url with client default browser */
    const kClass = "@idm.fr/sk_shell_execute;1";
    var obj = Components.classes[kClass].createInstance();
    obj = obj.QueryInterface(Components.interfaces.skIShellExecute);
    if(psExecutableName && psExecutableName != ''){
        obj.ShellExecuteInDirectory("open",
                                    psUrl+(psUrl.lastIndexOf("\\") == psUrl.length -1 ? "" : "\\")+psExecutableName,
                                    psParams, psUrl);
    }else{
        obj.ShellExecute("open", psUrl, psParams);
    }
}

/**
 * Runs an executable file. The path must be absolute.
 */
function executeFile(path) {
    try {

        var binaryFile = Components.classes["@mozilla.org/file/local;1"].
            createInstance().QueryInterface(Components.interfaces.nsILocalFile);
        binaryFile.initWithPath(path);
        if (binaryFile.exists()) {
            if (binaryFile.isExecutable()) {
                var processLauncher = Components
                    .classes["@mozilla.org/process/util;1"]
                    .createInstance(Components.interfaces.nsIProcess);
                processLauncher.init(binaryFile);
                // false => non blocking
                processLauncher.run(false, null,null);
            }
            else
                throw "The file " + binaryFile.path + " is not executable";
        }
        else
            throw "The file " + binaryFile.path + " doesn't exist";
    } catch (err) {
        alert(err);
        throw "ERROR in executeFile("+ path +") : "+err;
    }
}
/******
Affiche les messages dans la jsconsole
stringToLog         ---> message
******/
function alertDebug( stringToLog) {
    jsLog(stringToLog);
}

/**
 * Returns the current operating system. Can be 'mac', 'windows' or 'linux'
 */
function getOS() {
    var userAgentString = navigator.userAgent;
    if (userAgentString.indexOf("Mac") > -1)
        return 'mac';
    else if (userAgentString.indexOf("Linux") > -1)
        return 'linux';
    else return 'windows';
}
function BinaryLauncher(files) {
    this.init(files);
}

/**************************************************
 * BinaryLauncher - launches a binary located in chrome/<chrome_path>/bin
 * Each binary should be located in a subdirectory of bin. It expects a
 * hash giving the subdirectory and the binary to launch for each platform
 * 
 * For instance, if you have:
 *
 * chrome/ldoce5/bin/cae/windows_bin.exe
 * chrome/ldoce5/bin/cae/lin/linux_bin.sh
 * chrome/ldoce5/bin/cae/mac/mac_bin.sh
 *
 * You call:
 * var launcher = new BinaryLauncher({
 *      cae: {
 *          linux: 'lin/linux_bin.sh',
 *          windows: 'windows_bin.sh',
 *          mac: 'mac/mac_bin.sh'
 *      }
 * });
 *
 * launcher.launch('cae');
 */
BinaryLauncher.prototype.init = function (files) {
    this.os = getOS();
    this.files = files;

    var dirService = Components
        .classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties);
    this.binFile = dirService.get("AChrom",
            Components.interfaces.nsILocalFile);
    var prefService = Components.classes["@mozilla.org/preferences;1"].
        getService(Components.interfaces.nsIPref);
    var defaultUrl = prefService.GetCharPref("browser.chromeURL");
    if (defaultUrl.match(/^chrome:\/\/([^\/]+)\//))
        this.binFile.append(RegExp.$1);
    else
        throw "Can't locate the current chrome" 
    this.binFile.append("bin");
}

BinaryLauncher.prototype.launch = function(type) {
    try {
        var files = this.files[type];
        if (!files)
            throw "No such external binary: " + type;
        var osFile = this.files[type][this.os];
        if (!osFile)
            throw "No binary for this platform: " + this.os;
        var nsiLocalFile = Components.classes["@mozilla.org/file/local;1"].
            createInstance().QueryInterface(Components.interfaces.nsILocalFile);
        var file = nsiLocalFile.initWithFile(this.binFile);
        var relativePath = type + "/" + osFile;
        var splitPath = relativePath.split("/");
        for (var i in splitPath)
            nsiLocalFile.append(splitPath[i]);
        executeFile(nsiLocalFile.path);
    }
    catch(e) {
        alert(e)
    }
}

/******
Affiche les messages dans la jsconsole
stringToLog         ---> message
******/
var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function jsLog( stringToLog ) {
    aConsoleService.logStringMessage("[log] " + stringToLog);
}

function jsErr( stringToLog, e ) {
    try {(0)()} catch (e) {
        return stringToLog + " " + e.message + ":\n" + e.stack.replace(/^.*?\n/,'').
            replace(/(?:\n@:0)?\s+$/m,'').
            replace(/^\(/gm,'{anonymous}(').
            split("\n");
        }
}
/******
Ecrit les message dans le fichier de log
stringToLog         ---> message
******/
var gbFirstTimeForThisSession = true;
var xiL_file = "log.txt";
function txtLog( stringToLog ) {
    var xiO_File = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance().QueryInterface(Components.interfaces.nsIFileOutputStream);
    var MODE_CREATE = 0x08;
    var MODE_WRONLY = 0x02;
    var MODE_TRUNCATE = 0x20;
    if (gbFirstTimeForThisSession ) {
        xiO_File.init(xiL_file, MODE_WRONLY | MODE_CREATE | MODE_TRUNCATE, 0664, 0);//Open the file to write (Truncate the content)
        gbFirstTimeForThisSession = false;
    }else{
        xiO_File.init(xiL_file, MODE_WRONLY | MODE_CREATE , 0664, 0);//Open the file to write (Truncate the content)
    }
    xiO_File.write(shtmlContent, shtmlContent.length)
    xiO_File.flush()
    xiO_File.close()
}


/******
Cree une boite de confirmation avec un titre puis quitte l'application
TitleAppli              ---> titre du futur alert
QuitLabel               ---> message du futur alert
yesLabel                ---> text ok
noLabel                 ---> text cancel
******/
function closeAppli(TitleAppli,QuitLabel,yesLabel,noLabel){
    var result = ConfirmWithTitle(TitleAppli,QuitLabel,yesLabel,noLabel)?0:1;
    switch (result){
        case 0: //close
            killAppli();
        case 1: //don't close
            return false;
    }
    return true;
}

/******
Quitte l'application
******/
function killAppli() {
    try {
        var plip = Components.classes["@mozilla.org/commandlinehandler/general-startup;1?type=killAll"].createInstance().QueryInterface(Components.interfaces.nsICmdLineHandler);
        plip.chromeUrlForTask();
    } catch (err) {
        top.window.close();
    }
}

/******
Fait perdre du temps
pnms        ---> temps en milliseconde
******/
function sleep(pnms){
    var date=new Date();
    var currentTime = date.getTime();
    var instantTime=currentTime;
    while (instantTime<currentTime+pnms) instantTime=new Date().getTime();
}

/******
Liste toutes les proprietes et methodes d'un objet
obj        ---> objet
pbFull     ---> boolean to show value of properties/method
******/
function showObj(obj, pbFull){
    var text = "";
    for(var i in obj){
        text += i + (pbFull?" : " + eval("obj."+i) : '') + " ; ";
    }
    alertDebug(text)
}

/******
Pour enlever tous les enfants d'un element
******/
function emptyElement(poElt){
    try{
        while (poElt.lastChild != null) {
            poElt.removeChild(poElt.lastChild);
        }
    }catch(e){
        throw ("ERROR function emptyElement("+poElt+") :\n"+e);
    }
}

/******
Pour afficher les values d'un cursor, peut etre tres util pour le debug
******/
function showCursor(psLabel, poCursor){
    try{
        if(!poCursor){
            jsLog(psLabel+" : cursor is undef");
            return;
        }
        var txt = psLabel+" : ";
        if(poCursor.GetCount() == 0){
            txt += "cursor is empty";
            return;
        }
        for(var i=0;i<poCursor.GetCount();i++){
            txt += poCursor.GetElement(i)+(i < poCursor.GetCount()-1?" ; ":"");
        }
        jsLog(txt);
    }catch(e){
        throw ("ERROR function showCursor("+psLabel+", "+poCursor+") :\n"+e);
    }
}

/******
return array from cursor
******/
function cursorToArray(poCursor){
  if(!poCursor || poCursor.GetCount() < 1){
    return new Array();
  }
  var data = new Array();
  for(var i=0;i<poCursor.GetCount();i++){
      data.push(poCursor.GetElement(i));
  }
  return data;
}

/******
Pour selectionner le tab qu'il faut (selected ne fonctionne pas avec mozilla: BUG)
******/
function selectTab(tabsId,tabToSelectId){
    document.getElementById(tabsId).selectedItem = document.getElementById(tabToSelectId);
}

/******
Save file file skfs and execute it by system, if failed it can be saving on disk
******/
function saveFileAndExecuteIt(psFileName, poFile, pbSaveOnFailed) {
  var isLaunched = false;
  const MyProfile = Components.classes["@mozilla.org/profile/manager;1"].createInstance().QueryInterface(Components.interfaces.nsIProfileInternal);

  var sTargetFile = MyProfile.getProfileDir(MyProfile.currentProfile);
  sTargetFile.append("cache");
  var out = sTargetFile.QueryInterface(Components.interfaces.nsILocalFile);
  if(!out.exists()){
    out.create(out.DIRECTORY_TYPE, 0755);
  }
  psFileName = psFileName.slice(psFileName.lastIndexOf('/')+1, psFileName.length);
  sTargetFile.append( psFileName );
  try {
    sTargetFile = sTargetFile.QueryInterface(Components.interfaces.nsILocalFile);
    if(navigator.userAgent.indexOf("Mac")>-1) {
      poFile.GetData().WriteToLocalFile(sTargetFile);
      sTargetFile.launch();
    } else {
      var xiFilespec = Components.classes["@mozilla.org/filespec;1"].createInstance(Components.interfaces.nsIFileSpec);
      xiFilespec.nativePath = sTargetFile.path;
      poFile.GetData().WriteToFile(xiFilespec.nativePath);
      openDefBrowser(sTargetFile.path);
    }
    isLaunched = true;
  } catch (err) {
    isLaunched = false;
  }
  if(pbSaveOnFailed && !isLaunched && sTargetFile.exists())
      saveAs(psFileName, poFile);
}
function saveAs(psFileName, poFile) {
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance( nsIFilePicker );
  fp.init(window, "Save as...", nsIFilePicker.modeSave);
  fp.defaultString = psFileName;
  fp.appendFilters( nsIFilePicker.filterAll );
  if ( fp.show( ) == nsIFilePicker.returnOK && fp.file ) {
      var xiFilespec = Components.classes["@mozilla.org/filespec;1"].createInstance().QueryInterface(Components.interfaces.nsIFileSpec);
      xiFilespec.nativePath = fp.file.path;
      poFile.GetData().WriteToFile(xiFilespec.nativePath);
  }
}
function clearCache(){
  const MyProfile = Components.classes["@mozilla.org/profile/manager;1"].createInstance().QueryInterface(Components.interfaces.nsIProfileInternal);
  var sTargetFile = MyProfile.getProfileDir(MyProfile.currentProfile);
  sTargetFile.append("cache");
  if(sTargetFile.exists()){
  sTargetFile.remove(true);
  }
}



function allwaysOnTopObj(psWindowClass){
    this._init(psWindowClass);
}
allwaysOnTopObj.prototype = {
    _init: function (psWindowClass){
        this._bMenu = false;
        try {
            this.skIWindowPos = Components.classes["@idm.fr/sk_window_pos;1"].getService(Components.interfaces.skIWindowPos);
        }
        catch(e) {
            jsLog("No sk_window_pos found");
            // do nothing
            // we don't have sk_window_pos on Mac or Linux
        }
        this.windowClass = (psWindowClass ? psWindowClass : "");
        this.state = false;
        this.addMenu();
    },
    stopAlwaysOnTop: function (){
        if(Components.classes["@idm.fr/sk_window_pos;1"] && this.skIWindowPos){
            this.skIWindowPos.WindowPos(this.skIWindowPos.NOTOPMOST);
            return false;
        }
        return false;
    },
    startAlwaysOnTop: function (){
        if (this.skIWindowPos){
            this.skIWindowPos.WindowPos(this.skIWindowPos.TOPMOST);
            return true;
        }
        return false;
    },
    addMenu: function (){
        if (!this._bMenu && this.skIWindowPos){
            try{
                this.skIWindowPos.AddMenuEntry(this.windowClass);
                this._bMenu = true;
            }catch(e){
                jsLog(e);
            }
        }
    },
    toggle: function(){
        try{
            if(this.state){
                this.state = this.stopAlwaysOnTop();
            }else{
                this.state = this.startAlwaysOnTop();
            }
        }catch(e){
            jsLog(e);
        }
    }
}


//var allwaysOnTop = new allwaysOnTopObj();

//Convert html and hexadecimal entities to unicode characters
function convertEntitiesToUnicode(psString) {
    try {
        var aHtmlEntities = [["&agrave;", ""],
                             ["&aacute;", ""],
                             ["&Aacute;", ""],
                             ["&iacute;", ""],
                             ["&egrave;", ""],
                             ["&eacute;", ""],
                             ["&oacute;", ""],
                             ["&amp;", "&"]];
        var sString = psString;
        var i;

        for (i=0; i<aHtmlEntities.length; i++)
           sString = sString.replace(aHtmlEntities[i][0], "#1#" + aHtmlEntities[i][1], "g");
    	
        //replace numeric hexa entities by honest ucs-2 characters
        sString = sString.replace(/&#x([^;]+);/gi,
                                  function(poMatch, piValue) { return String.fromCharCode(parseInt(piValue, 16)); }
                                 );

        return sString;
    } catch (err) {
       throw ("ERROR function convertEntitiesToUnicode:\n" + err);
    }
}

/*Selection lors du focus et deselection lors du blur*/

function focusTextBox(){
    var aTxt = document.getElementsByTagName("textbox");
    for(var i=0; i<aTxt.length;i++){
        aTxt[i].addEventListener("focus", function (e){
                                             var obj = e.target;
                                             obj.select();
                                          }, true);
        aTxt[i].addEventListener("blur", function (e){
                                            var obj = e.target;
                                            obj.selectionEnd = 0;
                                            obj.selectionStart = 0;
                                         }, true);
    }
}
