var arl;
var displaySearchResultsCallback;
var gsPhoneticSearch = "";

function init(pArl, pDisplaySearchResultsCallback) {
    arl = pArl;
    displaySearchResultsCallback = pDisplaySearchResultsCallback;
}

function addPhoneticCharacter(psCharacter) {
    try {
        var oTextbox  = document.getElementById("ss-textbox");
        var sSearch   = oTextbox.value;

        oTextbox.value = sSearch + psCharacter;
        phoneticSearch(true);
    } catch (err) {
       winGM.jsLog("ERROR function addPhoneticCharacter:\n" + err);
    }
}

function clearSoundSearchForm() {
    try {
        var oTextbox  = document.getElementById("ss-textbox");
        var oCounter  = document.getElementById("ss-counter");
        var oFindBtn  = document.getElementById("ss-find-btn");

        oTextbox.value     = "";
        oCounter.removeAttribute("show");
        oFindBtn.collapsed = true;
    } catch (err) {
       winGM.jsLog("ERROR function clearSoundForm:\n" + err);
    }
}

function insertKeyboardCharacter(poTextbox, poEvent) {
    try {
        var iPos = poTextbox.selectionStart;

        //Keys left & right
        if(poEvent.keyCode == 37 || poEvent.keyCode == 39)
            return;
        //Keys backspace & suppr.
        if(poEvent.keyCode == 8 || poEvent.keyCode == 46)
            poTextbox.setSelectionRange(iPos, iPos);
        if(poEvent.keyCode > 32) {
            poTextbox.value = gsPhoneticSearch;
            poTextbox.setSelectionRange(iPos-1, iPos-1);
        }
        phoneticSearch(true);
    } catch (err) {
       winGM.jsLog("ERROR function insertKeyboardCharacter:\n" + err);
    }
}

function phoneticSearch(pbUpdateCounter) {
    try {
        var searchResults = null;
        var oIndexResult, oCursor;
        var oTextbox  = document.getElementById("ss-textbox");
        var oFindBtn  = document.getElementById("ss-find-btn");
        var oCounter  = document.getElementById("ss-counter");
        var sSearch   = oTextbox.value;
        var iResultNb;

        gsPhoneticSearch = oTextbox.value;

        if(!sSearch.replace(/[\?\*]/gi,"").length)
            iResultNb = 0;
        else {
            if (!sSearch.length)
                return;
            oIndexResult = winGM.skTabManager.getSkTable(arl).SearchExpression(sSearch, false, null, null);
            oCursor      = oIndexResult.GetDocumentList();
            iResultNb    = oCursor.GetCount();
        }
        searchResults = new Array();

        //Update the counter
        if (iResultNb == 0)
            oCounter.removeAttribute("show");
        else
            oCounter.setAttribute("show", "true");
        oCounter.setAttribute("value", "Results : " + iResultNb);

        //Show/Hide the button 'Find'
        oFindBtn.collapsed = (iResultNb == 0);

        if (pbUpdateCounter)
           return;

        for(var i=0; i<iResultNb; i++) {
            iIdx = oCursor.GetElement(i);
            searchResults.push(iIdx);
        }
        
        displaySearchResultsCallback(searchResults);
    } catch (err) {
       winGM.jsLog("ERROR function phoneticSearch:\n" + err);
    }
}
